; Use https://github.com/nstbayless/asm6f
INCNES "akira_ru_v1.1.nes"

; Macros
SEEK EQU SEEKABS
SKIP EQU SKIPREL

MACRO SKIPTO pos
    if ($ >= 0)
        SKIP pos - $
        ; just to be safe.
        if ($ != pos)
            ERROR "failed to skipto."
        endif
    endif
ENDM
FROM EQU SKIPTO

MACRO BANK bank
    SEEK (bank * $2000) + $10
ENDM
; End Macros


; iNES
SEEK $06
db $40, $00 ; MMC3, H Mirroring


BANK $0E
BASE $C000

; _MAIN:
FROM $C091
; LDA #$00
  STA $A000 ; STA $8000 ; Установка V Mirroring в bfs, нет в оригинале

; _nmi_apu_play:
FROM $C289
  JMP SetApuPlay
ReturnSetApuPlay:

; loc_15C273:
FROM $C453
  LDX #$00
  STX $8000
  LDA #$04
  STA $8001
  LDA #$02
  STA $8000
  STX $8001
  INX
  JMP SetScreenSplit
ReturnSetScreenSplit:

; sub_15C69E: Перед телевизором с толпой, если идти в город
FROM $C939
  JSR SetTlmBank ; LDA $037B | STA $8001

; loc_15C869:
FROM $CAEE
  JSR SetTlmBank ; LDA $037B | STA $8001

; loc_15C89F: После грузовика и человека в чёрном
FROM $CB23
  JSR SetTlmBank ; LDA $037B | STA $8001

; loc_15C8C5: Экран пароля
FROM $CB48
  JSR SetTlmBank ; LDA $037B | STA $8001

; loc_15CAF5:
FROM $D1DA
  JSR SetTlmBank ; LDA $037B | STA $8001

; sub_15CD03:
FROM $D384
  JSR SetTlmBank ; LDA $037B | STA $8001

; sub_15CDFE: Проверяется перед телевизором с толпой, но не выполняется
;             _tlm_prg_bank_nmi_draw0: -> _tlm_prg_bank_nmi_draw0_1:
FROM $D46C
  JSR SetTlmBank ; LDA $037B | STA $8001

; _far_call:
FROM $D5DB
  JMP SetFarCall_1
ReturnSetFarCall_1:
FROM $D5EE
  JMP SetFarCall_2
  NOP
ReturnSetFarCall_2:

; _mmc_reload:
FROM $D69D
; + mirroring
  ; LDA $0E
  ; CMP #$40
  ; ROL A
  ; STA $A000

  LDA #$06
  STA $8000
  LDA $0E
  ; AND #$3F
  STA $8001

  LDA #$07
  STA $8000
  LDA $0F
  STA $8001

  LDA #$00
  STA $8000
  LDA $10
  ASL A
  STA $8001

  LDA #$01
  STA $8000
  LDA $11
  JMP SetReload

; _get_msg_block_prg_and_idx:
FROM $D88C
  JMP SetMsgBlock
ReturnSetMsgBlock:

; loc_15D32D:
FROM $D942
  JSR SetTlmBank ; LDA $037B | STA $8001

; _tlm_chr_setup:
FROM $D95E
; LDA $037B
; ASL A
; TAY
; LDX $D978,Y
  LDA #$00
  STA $8000
  TXA
  ASL A
  STA $8001

  INX
  LDA #$01
  STA $8000
  TXA
  ASL A
  STA $8001

  LDA #$02
  JMP SetTlmChr

; _far_apu_load_param:
FROM $F3F3
  JMP SetFarApuLoad
ReturnSetFarApuLoad:


FROM $FEC5
MMC3Init:
  SEI
  CLD
  LDA #$00
  STA $8000 ; Fixed $C000-$FFFF
  ;STA $A000 ; V Mirroring
  STA $A001 ; Disable RAM
  STA $E000 ; Disable IRQ
  JMP $C040

SetTlmBank:
  LDA #$07
  STA $8000
  LDA $037B
  RTS

SetApuPlay:
  LDX #$07
  STX $8000
  STA $8001
  JMP ReturnSetApuPlay

SetScreenSplit:
  LDA #$03
  STA $8000
  STX $8001
  INX
  LDA #$04
  STA $8000
  STX $8001
  INX
  LDA #$05
  STA $8000
  STX $8001
  JMP ReturnSetScreenSplit

SetFarCall_1:
  LDA #$06
  STA $8000
  STX $8001
; or mirroring
  ; LDA #$06
  ; STA $8000
  ; TXA
  ; AND #$3F
  ; STA $8001
  ; TXA
  ; CMP #$40
  ; ROL A
  ; STA $A000
  JMP ReturnSetFarCall_1
SetFarCall_2:
  LDA #$06
  STA $8000
  PLA
  STA $8001
; or mirroring
  ; TAX
  ; LDA #$06
  ; STA $8000
  ; STX $8001
  ; TXA
  ; AND #$3F
  ; STA $8001
  ; TXA
  ; CMP #$40
  ; ROL A
  ; STA $A000
  JMP ReturnSetFarCall_2

SetReload:
  ASL A
  STA $8001

  LDA #$02
  STA $8000
  LDA $12
  STA $8001

  LDA #$03
  STA $8000
  LDA $13
  STA $8001

  LDA #$04
  STA $8000
  LDA $14
  STA $8001

  LDA #$05
  STA $8000
  LDA $15
  STA $8001
  RTS

SetMsgBlock:
  LDA #$07
  STA $8000
  LDA $D896,X
  JMP ReturnSetMsgBlock

SetTlmChr:
  LDX $D979,Y
  STA $8000
  STX $8001
  INX
  LDA #$03
  STA $8000
  STX $8001
  INX
  LDA #$04
  STA $8000
  STX $8001
  INX
  LDA #$05
  STA $8000
  STX $8001
  ;TYA ; Не используется
  RTS

SetFarApuLoad:
  LDY #$07
  STY $8000
  STA $8001
  JMP ReturnSetFarApuLoad

FROM $FFFC
  db <MMC3Init, >MMC3Init
